import processing.sound.*;
SoundFile musik;
SoundFile schritte;
SoundFile sprung;
SoundFile motor;
SoundFile crash;

float x = 400;
float y = 600;
float speedX = 6;
float speedY = 0;
float gravity = 2.5;
float jumpSpeed = -21;
float groundY = y;
float jumpHeight = 530;
boolean jumping = false;

float ax = width;  // start position
int autoSpeed = 50;  // Fahrgeschwindigkeit des Autos

PImage bg;  // Hintergrundbild
float bgX = 0;  // X-Position des Hintergrundbildes
PImage meinBild; // Sterne

//PImage auto;  // Auto blau
PImage[] auto = new PImage[3];
PImage[] autoweiss = new PImage[3];

int frameDelayAuto = 20; // Zeitverzögerung in Millisekunden zwischen den Animationsschritten
int lastFrameUpdateAuto = 0; // Zeitpunkt des letzten Animations-Updates in Millisekunden
int currentFrameAuto = 0;
int farbe = 1;

PImage[] figur = new PImage[4];
int frameDelay = 55; // Zeitverzögerung in Millisekunden zwischen den Animationsschritten
int lastFrameUpdate = 0; // Zeitpunkt des letzten Animations-Updates in Millisekunden
int currentFrame = 0;


// 1. Button
int buttonX = 500;
int buttonY = 500;
int buttonWidth = 200;
int buttonHeight = 100;

// 2. Button
int buttonX2 = 40;
int buttonY2 = 600;
int buttonWidth2 = 200;
int buttonHeight2 = 100;

// 3. Button
int buttonX3 = 625;
int buttonY3 = 550;
int buttonWidth3 = 200;
int buttonHeight3 = 100;

int currentPage = 1;


void setup() {
  size(1200, 800);
  bg = loadImage("Hintergrund.png");
  meinBild = loadImage("hintergrund1.jpeg");
  
  auto[0] = loadImage("Auto1.png");
  auto[1] = loadImage("Auto2.png");
  auto[2] = loadImage("Auto3.png");
  
  autoweiss[0] = loadImage("Autoweiss1.png");
  autoweiss[1] = loadImage("Autoweiss2.png");
  autoweiss[2] = loadImage("Autoweiss3.png");
  
  figur[0] = loadImage("Figur1.png");
  figur[1] = loadImage("Figur2.png");
  figur[2] = loadImage("Figur3.png");
  figur[3] = loadImage("Figur4.png");
  
  // Sounds
  musik = new SoundFile(this, "Song.mp3");
  schritte = new SoundFile(this, "step.aif");
  
  sprung = new SoundFile(this, "uf.aif");
  motor = new SoundFile(this, "motor.aif");
  crash = new SoundFile(this, "crash.aif");
}

void draw() {
  image(meinBild,0,0,1200,800);
  if(currentPage ==1){
    strokeWeight(2);
    stroke(#060150);
    fill(#FFF1AD);
    rect(buttonX, buttonY, buttonWidth, buttonHeight);
  
    fill(#060150);
    PFont mono;
    mono = createFont("ComicNeueSansID 2.ttf",100);
    textFont(mono);
    text("NIGHT RUNNER",600,400);
    PFont duos;
    duos = createFont("ComicNeueSansID 2.ttf",40);
    textAlign(CENTER);
    textFont(duos);
    text("WEITER",600,550);
    triangle(590,560,590,590,620,575);
  }
  else if(currentPage ==2){
      PFont mono;
      mono = createFont("ComicNeueSansID 2.ttf",40);
      textFont(mono);
      text("Drücke auf r",250,430);
      text("für die Spielanleitung",250,480);
      text("Drücke auf s",950,430);
      text("für Spielbeginn",950,480); 
    }
  else if(currentPage ==3){
    textAlign(LEFT);
    PFont mono;
    mono = createFont("ComicNeueSansID 2.ttf",40);
    textFont(mono);
    fill(#060150);
    text("WILLKOMMEN BEI NIGHT RUNNER",40,150);
    text("Das Ziel unseres Spiels, ist es sicher durch den",40,300);
    text("Strassenverkehr von New York zu kommen.",40,350);
    text("Es gibt viele Taxis, die einem ",40,400);
    text("in rasanter Geschwindigkeit entgegenkommen.",40,450);
    text("Um die Taxis zu überwinden, drücke Leertaste!",40,500);
    strokeWeight(2);
    stroke(#060150);
    fill(#FFF1AD);
    rect(buttonX2, buttonY2, buttonWidth2, buttonHeight2);
    fill(#060150);
    text("START",60,670);
  }
  else if(currentPage ==4){
  
  // Zeichne das Hintergrundbild an seiner aktuellen Position
  image(bg, bgX, 0);
  
  // Bewege das Hintergrundbild nach links um 2 Pixel pro Frame
  bgX -= 6;
  
  // Wenn das Hintergrundbild aus dem Fenster verschwunden ist, setze es zurück an den rechten Rand
  if (bgX <= -bg.width / 2){
    bgX = 0;
  }
  
  
  // Bewege das Auto von rechts nach links
  ax -= autoSpeed; //10;
  
  // Check ob das Auto den linken Rand erreicht hat
  if (ax < -220) {
    ax = width + int(random(0, 600));  // Auto neu starten
    autoSpeed = int(random(30,40));  // Autotempo nach Zufall setzen
    farbe = int(random(1, 3));  // Autofarbe per Zufall bestimmen (blau oder weiss)
    
    motor.play();
  }
  
  // Player wird gezeichnet
  image(figur[currentFrame], x, y);
  
  // Auto zeichnen
  if(farbe == 1) {
    image(auto[currentFrameAuto], ax, 640);
  }
  else
  {  
    image(autoweiss[currentFrameAuto], ax, 640);
  }
 
  // Überprüfen, ob genügend Zeit seit dem letzten Animations-Update vergangen ist
  if (millis() - lastFrameUpdateAuto > frameDelayAuto) {
    // Update der Animation
    currentFrameAuto = (currentFrameAuto + 1) % auto.length;
    // Aktualisieren Sie den Zeitpunkt des letzten Animations-Updates
    lastFrameUpdateAuto = millis();
  }

  
  // Player fällt, wenn es nicht auf dem Boden ist
  if (y < groundY) {
    speedY += gravity;
  }
  
  // Player springt nur, wenn Leertaste gedrückt wird und es auf dem Boden ist
  if (keyPressed && key == ' ' && !jumping && y >= groundY) {
    jumping = true;
    speedY = jumpSpeed;
    y += speedY;
    frameDelay = 200;
    
    schritte.stop();
    sprung.play();
  }
  
  // Player bewegt sich hoch, wenn es springt
  if (jumping) {
    y += speedY;
    if (y <= groundY - jumpHeight) {
      speedY *= -2;
    }
    if (y >= groundY) {
      jumping = false;
      schritte.loop();
      frameDelay = 55;
    }
  }
  
  
  // Überprüfen, ob genügend Zeit seit dem letzten Animations-Update vergangen ist
  if (millis() - lastFrameUpdate > frameDelay) {
    // Update der Animation
    currentFrame = (currentFrame + 1) % figur.length;
    // Aktualisieren Sie den Zeitpunkt des letzten Animations-Updates
    lastFrameUpdate = millis();
  }
  //Kollision
  if(x > ax && x < ax + 220 && y > 560){
    crash.play();
    ax = width + int(random(0, 600));  // Auto neu starten
    y = 600;
    currentPage = 6;
  } 
}

 else if(currentPage == 6){
  textAlign(CENTER);
  musik.stop();
  schritte.stop();
  strokeWeight(2);
  stroke(#060150);
  fill(#FFF1AD);
  rect(buttonX, buttonY, buttonWidth, buttonHeight);
  fill(#060150);
  PFont mono;
  mono = createFont("ComicNeueSansID 2.ttf",80);
  textFont(mono);
  text("GameOver", 600, 400);
  textSize(20);
  text("Zurück", 600, 530);
  text("zur Startseite", 600, 550);
  triangle(590,560,590,590,620,575);
 

  if(mousePressed && mouseX > buttonX && mouseX < buttonX+buttonWidth && mouseY > buttonY && mouseY < buttonY+buttonHeight){
    zurueckZurStartseite();
  }
  }
 
}

void mousePressed() {
  if (currentPage ==1 && mouseX > buttonX && mouseX < buttonX + buttonWidth &&
      mouseY > buttonY && mouseY < buttonY + buttonHeight) {
      currentPage = 2;
  }
  if (currentPage ==3 && mouseX > buttonX2 && mouseX < buttonX2 + buttonWidth2 &&
      mouseY > buttonY2 && mouseY < buttonY2 + buttonHeight2) {
      musik.loop();
      schritte.loop();
      currentPage = 4;
  }
}
void keyPressed(){
    
  if(currentPage == 2){
    if(key == 'r'){
      currentPage = 3;
    }
    else if(key == 's'){
      musik.loop();
      schritte.loop();
      currentPage = 4;
    }
  }  
}
void zurueckZurStartseite(){
  currentPage = 1;
}

  
